#pragma once

#include "qrencode.h"

#ifdef __cplusplus
extern "C" {
#endif

void WINAPI GeneratePNGW(LPWSTR fileName, LPWSTR text, int margin, int size, QRecLevel level);
void WINAPI GeneratePNGA(LPSTR fileName, LPSTR text, int margin, int size, QRecLevel level);
#ifdef UNICODE
#define GeneratePNG  GeneratePNGW
#else
#define GeneratePNG  GeneratePNGA
#endif // !UNICODE

HBITMAP WINAPI GetHBitmapW(LPWSTR text, int margin, int size, QRecLevel level);
HBITMAP WINAPI GetHBitmapA(LPSTR text, int margin, int size, QRecLevel level);
#ifdef UNICODE
#define GetHBitmap  GetHBitmapW
#else
#define GetHBitmap  GetHBitmapA
#endif // !UNICODE

void WINAPI GenerateBMPW(LPWSTR fileName, LPWSTR text, int margin, int size, QRecLevel level);
void WINAPI GenerateBMPA(LPSTR fileName, LPSTR text, int margin, int size, QRecLevel level);
#ifdef UNICODE
#define GenerateBMP  GenerateBMPW
#else
#define GenerateBMP  GenerateBMPA
#endif // !UNICODE

void WINAPI GetPNGW(LPWSTR text, int margin, int size, QRecLevel level, LPINT bufSize, __deref_opt_out void **ppvBits);
void WINAPI GetPNGA(LPSTR text, int margin, int size, QRecLevel level, LPINT bufSize, __deref_opt_out void **ppvBits);
#ifdef UNICODE
#define GetPNG  GetPNGW
#else
#define GetPNG  GetPNGA
#endif // !UNICODE

void WINAPI DestroyBuffer(void* buffer);

#ifdef __cplusplus
}
#endif
