#pragma once

#include "qrencode.h"
#include "qrinput.h"
#include "qrspec.h"

#ifdef __cplusplus
extern "C" {
#endif

#define WIDTHBYTES(i) (((i) + 31) / 32 * 4)

/* structure to store PNG image bytes */
struct mem_encode
{
  char *buffer;
  size_t size;
};

QRcode* MakeCode(LPWSTR text, QRecLevel level);
QRcode* MakeCodeA(LPSTR text, QRecLevel level);

int writePNG(QRcode *qrcode, LPWSTR outfile, int margin, int size);
int generatePNG(QRcode *qrcode, mem_encode* memory, int margin, int size);

int
AnsiToUnicodeString(
 LPSTR pAnsi,
 LPWSTR pUnicode,
 DWORD StringLength
 );

/*
int
UnicodeToAnsiString(
 LPWSTR pUnicode,
 LPSTR pAnsi,
 DWORD StringLength
 );
*/

LPWSTR
AllocateUnicodeString(
 LPSTR  pAnsiString
 );

void
FreeUnicodeString(
 LPWSTR  pUnicodeString
 );

#ifdef __cplusplus
}
#endif
